apiVersion: v1
{% if loki_storage == 's3' %}
kind: Secret
{% else %}
kind: ConfigMap
{% endif %}
metadata:
  name: {{ loki_name }}
  namespace: {{ namespace }}
{% if loki_storage == 's3' %}
stringData:
{% else %}
data:
{% endif %}
  loki.yaml: |
    auth_enabled: {% if loki_auth_enabled | default(false) %}tru{% else %}fals{% endif %}e

    http_prefix:

    server:
      http_listen_address: 0.0.0.0
      grpc_listen_address: 0.0.0.0
      http_listen_port: 3100
      grpc_listen_port: 9095
      log_level: info

    distributor:
      ring:
        kvstore:
          store: memberlist

    ingester:
      lifecycler:
        ring:
          kvstore:
            store: memberlist
          replication_factor: 1
        final_sleep: 0s
      chunk_idle_period: 5m
      chunk_retain_period: 30s
      wal:
        enabled: true
        dir: /loki/wal

    #ingester:
    #  lifecycler:
    #    join_after: 10s
    #    observe_period: 5s
    #    ring:
    #      kvstore:
    #        store: memberlist
    #      replication_factor: 3
    #    final_sleep: 0s
    #  chunk_idle_period: 1m
    #  max_chunk_age: 1m
    #  chunk_retain_period: 30s
    #  chunk_encoding: snappy
    #  chunk_target_size: 1.572864e+06
    #  chunk_block_size: 262144
    #  flush_op_timeout: 10s

    #common:
    #  storage:
    #    s3:
    #      endpoint: minio:9000
    #      insecure: true
    #      bucketnames: loki-data
    #      access_key_id: loki
    #      secret_access_key: supersecret
    #      s3forcepathstyle: true

    memberlist:
      abort_if_cluster_join_fails: false
      dead_node_reclaim_time: 30s
      bind_addr: ['0.0.0.0']
      bind_port: 7946
      gossip_interval: 2s
      gossip_to_dead_nodes_time: 15s
      join_members:
      - {{ loki_name }}.{{ namespace }}.svc.{{ cluster_domain }}:7946
      left_ingesters_timeout: 30s
      max_join_backoff: 1m
      max_join_retries: 10
      min_join_backoff: 1s

{% if loki_storage == 's3' %}
    schema_config:
      configs:
      - from: 2020-01-01
        store: aws
        object_store: s3
        schema: v11
        index:
          period: 24h
          prefix: loki_

    storage_config:
      aws:
        bucketnames: {{ loki_s3_bucket }}
{% if loki_s3_flavor == 'minio' %}
        endpoint: {{ minio_api_address | urlsplit('hostname') }}:{{ minio_api_address | urlsplit('port') }}
        region: "{{ (s3_secret.resources[0].data['region'] | b64decode) if (s3_secret.resources[0].data['region'] is defined) else minio_region_name | default('us-east-1') }}"
        access_key_id: "{{ s3_secret.resources[0].data['access-key'] | b64decode }}"
        secret_access_key: "{{ s3_secret.resources[0].data['secret-key'] | b64decode }}"
{% elif loki_s3_flavor in [ 'ceph', 'rados', 'radosgw' %}
        endpoint: {{ radosgw_api_address | urlsplit('hostname') }}:{{ radosgw_api_address | urlsplit('port') }}
        region: "{{ loki_s3_region | default('us-east-1') }}"
        access_key_id: "{{ loki_s3_access_key }}"
        secret_access_key: "{{ loki_s3_secret_key }}"
{% endif %}
        insecure: true
        sse_encryption: false
        http_config:
          idle_conn_timeout: 90s
          response_header_timeout: 0s
          insecure_skip_verify: false
        s3forcepathstyle: true

    limits_config:
      max_cache_freshness_per_query: 10m
      reject_old_samples_max_age: 30m
{% elif loki_storage == 'fs' %}
    schema_config:
      configs:
      - from: 2020-01-01
        store: boltdb
        object_store: filesystem
        schema: v11
        index:
          prefix: index_
          period: 168h

    storage_config:
      boltdb:
        directory: /loki/index
      filesystem:
        directory: /loki/chunks

    limits_config:
      reject_old_samples_max_age: 168h
{% elif loki_storage == 'cassandra' %}
    schema_config:
      configs:
      - from: 2020-01-01
        store: cassandra
        object_store: cassandra
        schema: v11
        index:
          prefix: index_
          period: 168h
        chunks:
          prefix: chunk_
          period: 168h

    storage_config:
      cassandra:
        addresses: <comma-separated-IPs-or-hostnames>
        keyspace: <keyspace>
        auth: <true|false>
        username: <username> # only applicable when auth=true
        password: <password> # only applicable when auth=true

    limits_config:
      max_cache_freshness_per_query: 10m
      reject_old_samples_max_age: 30m
{% endif %}
      enforce_metric_name: false
      ingestion_rate_mb: 10
      ingestion_burst_size_mb: 20
      reject_old_samples: true
      split_queries_by_interval: 15m

    chunk_store_config:
      max_look_back_period: 336h

    table_manager:
      retention_deletes_enabled: true
      retention_period: 336h

    query_range:
      # make queries more cache-able by aligning them with their step intervals
      align_queries_with_step: true
      max_retries: 5
      parallelise_shardable_queries: true
      cache_results: true

    frontend:
      log_queries_longer_than: 5s
      compress_responses: true
      max_outstanding_per_tenant: 2048

    query_scheduler:
      max_outstanding_requests_per_tenant: 1024

    querier:
      query_ingesters_within: 2h

    compactor:
      working_directory: /loki/compactor
      shared_store: s3
